Index: formats/format_pcm.c
===================================================================
--- formats/format_pcm.c	(revision 325277)
+++ formats/format_pcm.c	(working copy)
@@ -96,10 +96,10 @@
 	return &s->fr;
 }
 
-static int pcm_seek(struct ast_filestream *fs, off_t sample_offset, int whence)
+static int pcm_seek_helper(struct ast_filestream *fs, off_t sample_offset, int whence, int codec_shift)
 {
 	off_t cur, max, offset = 0;
- 	int ret = -1;	/* assume error */
+	int ret = -1;	/* assume error */
 
 	cur = ftello(fs->f);
 	fseeko(fs->f, 0, SEEK_END);
@@ -137,14 +137,24 @@
 		ret = 0; /* successful */
 	} else {
 		if (offset > max) {
-			ast_log(LOG_WARNING, "offset too large %ld, truncating to %ld\n", (long) offset, (long) max);
-			offset = max;
+			ast_log(LOG_WARNING, "offset too large %ld, truncating to %ld\n", (long) offset, (long) max + codec_shift);
+			offset = max - 1;
 		}
 		ret = fseeko(fs->f, offset, SEEK_SET);
 	}
 	return ret;
 }
 
+static int pcm_seek_g722(struct ast_filestream *fs, off_t sample_offset, int whence)
+{
+	return pcm_seek_helper(fs, sample_offset, whence, -1);
+}
+static int pcm_seek(struct ast_filestream *fs, off_t sample_offset, int whence)
+{
+	return pcm_seek_helper(fs, sample_offset, whence, 0);
+}
+
+
 static int pcm_trunc(struct ast_filestream *fs)
 {
 	return ftruncate(fileno(fs->f), ftello(fs->f));
@@ -447,7 +457,7 @@
 	.exts = "g722",
 	.format = AST_FORMAT_G722,
 	.write = pcm_write,
-	.seek = pcm_seek,
+	.seek = pcm_seek_g722,
 	.trunc = pcm_trunc,
 	.tell = pcm_tell,
 	.read = pcm_read,
